#include <iostream>
#include <fstream>

#include "filetransfer.h"

using namespace arc;

int main() {

	URL downloadurl("file:///tmp/tmpfile");

	// let's download this url to std::cout
	std::cout << "Downloading " << downloadurl.Path() << " to stdout" << std::endl;
	FileTransfer ftr;

	try {
		ftr.Download(downloadurl, std::cout);
	} catch( FileTransferError e ) {
		std::cout << e.what() << std::endl;
		return 1;
	}

	std::cout << std::endl;

	std::ifstream file("/tmp/tmpfile2");
	if (!file) {
		std::cerr << "/tmp/tmpfiles2 does not exist" << std::endl;
		return 1;
	}	

	// let's upload this url to file:///tmp/tmpfile3
	URL uploadurl("file:///tmp/tmpfile3");
	try {
		std::cout << "Uploading /tmp/tmpfile2 to " << uploadurl.str() << std::endl;
		ftr.Upload(file, uploadurl);
	} catch( FileTransferError e ) {
		std::cout << e.what() << std::endl;
		return 1;
	}

	return 0;
}
