#include <iostream>

#include <arc/mdsdiscovery.h>
#include <arc/notify.h>

using namespace std;

int main() {

	SetNotifyLevel(DEBUG);

	URL atlas_giis("ldap://atlasgiis.nbi.dk:2135/O=Grid/Mds-Vo-Name=Atlas");
	
	std::list<URL> clusters;
	cout << "Getting clusters" << endl;
	try {
		clusters = GetResources(atlas_giis);
	} catch(ARCLibError e) {
		notify(ERROR) << e.what() << endl;
		return 1;
	}
    
	if (clusters.size()>0)
		cout << "Clusters found:" << endl;

	std::list<URL>::iterator it;
	for (it = clusters.begin(); it != clusters.end(); it++) {
		cout << it->Host() << endl;
	}
}
