#include "../../misc/log_time.h"

#include "xmlwrap.h"

#include "attribute.h"

const std::string FlOAttribute::empty_value("");

void FlOAttribute::serialize(XMLNode& x) const {
  x.name("attribute");
  XMLNode x_name(x,"name");
  x_name.content(name_);
  for(std::vector<const std::string>::const_iterator i = value_.begin();
                     i!=value_.end();++i) {
    XMLNode x_value(x,"value");
    x_value.content(*i);
  };
}

FlOAttribute* FlOAttribute::deserialize(const XMLNode& x) {
  if(!x) return NULL;
  if(x.name() != "attribute") return NULL;
  XMLNode* x_name = x.getNode("name");
  if(x_name == NULL) return NULL;
  FlOAttribute* a = new FlOAttribute();
  if(a == NULL) return NULL;
  a->multivalue_=true;
  a->name_=x_name->content(); delete x_name;
  for(int i = 0;;i++) {
    XMLNode* x_value = x.getNode("value",i);
    if(x_value == NULL) break;
    a->value_.push_back(x_value->content());
    delete x_value;
  };
  return a;
}

FlOAttribute::~FlOAttribute(void) {
}

