/*
 * Created on Nov 4, 2005
 *
 * TODO Implement it, then write some documentation
 *
 */
package se.umu.jobsubmission.impl.informationfinder;

import java.util.Hashtable;
import java.util.LinkedList;
import java.util.List;

import javax.naming.Context;
import javax.naming.NamingEnumeration;
import javax.naming.directory.Attributes;
import javax.naming.directory.DirContext;
import javax.naming.directory.InitialDirContext;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;

import javax.naming.directory.BasicAttribute;

import org.apache.log4j.Logger;

/**
 * @author tordsson
 *
 * TODO Add a proper description of this class. 
 */
public class LCGResourceFinder implements ResourceFinder {
	
	private static Logger logger = Logger.getLogger(LCGResourceFinder.class); 
	
    public List findResources(String indexServerURI, int timeout) 
    throws Exception {
    	
    	List resources = new LinkedList(); 
    	List indexServers = new LinkedList(); 
    	DirContext ctx = null; 
    	List result = null; 
 
    	// TODO: This does not work, LCG2 does also use 
    	// mds-vo-name=...
    	
    	if(indexServerURI.matches(".*:2135.*")) {
    		logger.error("LDAP server URL suggests ARC GIIS: " + indexServerURI); 
    		throw new Exception ("LDAP server URL suggests ARC GIIS: " 
    				+ indexServerURI); 
    	}
    	
    	try {
    		logger.info("Contacting: " + indexServerURI);
    		logger.info("Timeout is: " + timeout); 

    		Hashtable env = new Hashtable();
    		env.put(Context.INITIAL_CONTEXT_FACTORY, "com.sun.jndi.ldap.LdapCtxFactory");
    				
    		env.put("com.sun.jndi.ldap.connect.timeout", "" + timeout);
            env.put(Context.PROVIDER_URL, indexServerURI);
            
           ctx = new InitialDirContext(env);
            String[] returned_attrs = { "GlueInformationServiceURL" };            							 
            SearchControls controls = new SearchControls();
            controls.setCountLimit(0);
            controls.setTimeLimit(timeout);
            controls.setSearchScope(SearchControls.SUBTREE_SCOPE);
            controls.setReturningAttributes(returned_attrs);
            NamingEnumeration results = ctx.search("", 
            		"(objectclass=GlueInformationService)", 
					controls);
       
            while(results.hasMore()) {
                SearchResult searchResult = (SearchResult)(results.next());
                Attributes attributes = searchResult.getAttributes();
                if(attributes.size() == 0) {
                	logger.info("No attributes found"); 
                	continue;
                }
                
                NamingEnumeration attrs = attributes.getAll(); 
                while(attrs.hasMore()) {
                	BasicAttribute attr = (BasicAttribute) attrs.next(); 
                	String value = attr.get(0).toString();                 
                	if(value.indexOf("mds-vo-name=local") < 0) {
                		indexServers.add(value); 
                	}
                	else {
                		resources.add(value); 
                	}
                }
            }
    		
            result = new LinkedList(); 
            result.add(indexServers); 
            result.add(resources); 
    		
    	}
    	catch (Exception e) {
    		logger.warn("No resources found at " + indexServerURI); 
    		throw new Exception("No resources found at: " + indexServerURI, e); 
    	}
    	finally {
            if(ctx != null) {
                try {
                    ctx.close();                   
                } catch (Exception e) {
                	logger.warn("Error shutting down connection"); 
                }
            }
    	}
    	return result; 
    }

}
